package mnk.replace.fragments;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.location.Address;
import android.location.Geocoder;
import android.os.Bundle;
import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapView;
import com.google.android.gms.maps.MapsInitializer;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.storage.FileDownloadTask;
import com.google.firebase.storage.FirebaseStorage;
import com.google.firebase.storage.StorageReference;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Locale;

import mnk.replace.activities.NavigationDrawerActivity;
import mnk.replace.R;
import mnk.replace.model.ItemContent;
import mnk.replace.model.UserContent;

import static mnk.replace.fragments.ElementsMapFragment.DEFAULT_ZOOM;

/**
 * A simple {@link Fragment} subclass.
 */
public class DetailItemFragment extends Fragment {

    NavigationDrawerActivity parentActivity;

    public ItemContent.Item Item;

    // PROGRESS BAR
    Thread progressBarThread;
    int pStatus = 0;
    Handler handler = new Handler();

    // UI
    public ImageView imageView_detailItem;
    public ImageView imageView_detailItem_fullscreen;
    TextView editText_detailItem_description;
    TextView editText_detailItem_user;
    TextView textView_detailItem_description;
    TextView textView_detailItem_user;
    TextView textView_detailItem_distance;
    TextView editText_detailItem_distance;
    TextView textView_detailItem_date;
    TextView editText_detailItem_date;
    TextView textView_detailItem_location;
    TextView editText_detailItem_location;
    MapView mapView_detailItem;
    public GoogleMap googleMap;
    ProgressBar progressBar;
    public boolean isImageFitToScreen;
    ViewGroup.LayoutParams startLayoutParams;

    public DetailItemFragment() {
        // Required empty public constructor
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.fragment_detail_item, container, false);
        parentActivity = ((NavigationDrawerActivity)getActivity());
        imageView_detailItem = view.findViewById(R.id.imageView_detailItem);
        editText_detailItem_description = view.findViewById(R.id.editText_detailItem_description);
        editText_detailItem_user = view.findViewById(R.id.editText_detailItem_user);
        textView_detailItem_description = view.findViewById(R.id.textView_detailItem_description);
        textView_detailItem_user = view.findViewById(R.id.textView_detailItem_user);
        textView_detailItem_distance = view.findViewById(R.id.textView_detailItem_distance);
        editText_detailItem_distance = view.findViewById(R.id.editText_detailItem_distance);
        textView_detailItem_date = view.findViewById(R.id.textView_detailItem_date);
        editText_detailItem_date = view.findViewById(R.id.editText_detailItem_date);
        textView_detailItem_location = view.findViewById(R.id.textView_detailItem_location);
        editText_detailItem_location = view.findViewById(R.id.editText_detailItem_location);
        mapView_detailItem = view.findViewById(R.id.mapView_detailItem);
        imageView_detailItem_fullscreen = view.findViewById(R.id.imageView_detailItem_fullscreen);

        progressBar = view.findViewById(R.id.progressBar);
        parentActivity.fab.setVisibility(View.INVISIBLE);

        imageView_detailItem.setVisibility(View.INVISIBLE);
        editText_detailItem_description.setVisibility(View.INVISIBLE);
        editText_detailItem_user.setVisibility(View.INVISIBLE);
        textView_detailItem_description.setVisibility(View.INVISIBLE);
        textView_detailItem_user.setVisibility(View.INVISIBLE);
        textView_detailItem_distance.setVisibility(View.INVISIBLE);
        editText_detailItem_distance.setVisibility(View.INVISIBLE);
        textView_detailItem_date.setVisibility(View.INVISIBLE);
        editText_detailItem_date.setVisibility(View.INVISIBLE);
        textView_detailItem_location.setVisibility(View.INVISIBLE);
        editText_detailItem_location.setVisibility(View.INVISIBLE);
        mapView_detailItem.setVisibility(View.INVISIBLE);
        imageView_detailItem_fullscreen.setVisibility(View.INVISIBLE);

        isImageFitToScreen = false;

        imageView_detailItem.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setFullscreenImage();
            }
        });
        imageView_detailItem_fullscreen.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setFullscreenImage();
            }
        });

        // MAP
        mapView_detailItem.onCreate(savedInstanceState);
        mapView_detailItem.onResume(); // needed to get the map to display immediately

        try {
            MapsInitializer.initialize(getActivity().getApplicationContext());
        } catch (Exception e) {
            e.printStackTrace();
        }
        mapView_detailItem.getMapAsync(new OnMapReadyCallback() {
            @Override
            public void onMapReady(GoogleMap mMap) {
            googleMap = mMap;
            googleMap.addMarker(new MarkerOptions()
                    .position(new LatLng(Item.getLatitude(), Item.getLongitude()))
                    .title(Item.getDescription()));
            googleMap.moveCamera(CameraUpdateFactory
                    .newLatLngZoom(new LatLng(Item.getLatitude(), Item.getLongitude()), DEFAULT_ZOOM));
            }
        });

        // Inflate the layout for this fragment
        return view;

    }

    public void setFullscreenImage() {

        if(isImageFitToScreen) {

            isImageFitToScreen = false;
            imageView_detailItem.setVisibility(View.VISIBLE);
            editText_detailItem_description.setVisibility(View.VISIBLE);
            editText_detailItem_user.setVisibility(View.VISIBLE);
            textView_detailItem_description.setVisibility(View.VISIBLE);
            textView_detailItem_user.setVisibility(View.VISIBLE);
            textView_detailItem_distance.setVisibility(View.VISIBLE);
            editText_detailItem_distance.setVisibility(View.VISIBLE);
            textView_detailItem_date.setVisibility(View.VISIBLE);
            editText_detailItem_date.setVisibility(View.VISIBLE);
            textView_detailItem_location.setVisibility(View.VISIBLE);
            editText_detailItem_location.setVisibility(View.VISIBLE);
            mapView_detailItem.setVisibility(View.VISIBLE);
            imageView_detailItem_fullscreen.setVisibility(View.INVISIBLE);

        }
        else {

            isImageFitToScreen=true;
            imageView_detailItem.setVisibility(View.INVISIBLE);
            editText_detailItem_description.setVisibility(View.INVISIBLE);
            editText_detailItem_user.setVisibility(View.INVISIBLE);
            textView_detailItem_description.setVisibility(View.INVISIBLE);
            textView_detailItem_user.setVisibility(View.INVISIBLE);
            textView_detailItem_distance.setVisibility(View.INVISIBLE);
            editText_detailItem_distance.setVisibility(View.INVISIBLE);
            textView_detailItem_date.setVisibility(View.INVISIBLE);
            editText_detailItem_date.setVisibility(View.INVISIBLE);
            textView_detailItem_location.setVisibility(View.INVISIBLE);
            editText_detailItem_location.setVisibility(View.INVISIBLE);
            mapView_detailItem.setVisibility(View.INVISIBLE);
            imageView_detailItem_fullscreen.setVisibility(View.VISIBLE);

        }

    }

    @Override
    public void onResume() {
        super.onResume();

        // START PROGRESS BAR ANIMATE
        progressBarAnimate(true, progressBar);

        // WAIT FOR ITEM
        while(Item == null) {}

        // ACTION BAR BUTTONS
        if(parentActivity.filterItem != null) {
            if((parentActivity.firebaseManager.getFirebaseUser() == null) || (parentActivity.firebaseManager.getFirebaseUser().getUid().equals(Item.getUserId()) == false)) {
                parentActivity.actionBarShowDeleteItem(false);
            }
            else {
                parentActivity.actionBarShowDeleteItem(true);
            }
            parentActivity.actionBarShowFilterItem(false);
            parentActivity.actionBarShowViewItemsSelector(false, false);
        }

        parentActivity.deleteItem.setOnMenuItemClickListener(new MenuItem.OnMenuItemClickListener() {
            @Override
            public boolean onMenuItemClick(MenuItem item) {
            DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                switch (which){
                    case DialogInterface.BUTTON_POSITIVE:
                        //Yes button clicked
                        StorageReference photoRef = FirebaseStorage.getInstance().getReference("images/" + Item.getId() + ".jpg");
                        photoRef.delete();
                        parentActivity.firebaseManager.getFirebaseDataReference().child("items//" + Item.getId()).removeValue();
                        Toast.makeText(getContext(), "Item deleted", Toast.LENGTH_LONG).show();
                        // ACTION BAR VISIBILITY
                        parentActivity.actionBarShowDeleteItem(false);
                        // FAB VISIBILITY
                        parentActivity.fab.setVisibility(View.VISIBLE);
                        getFragmentManager().popBackStackImmediate();
                        break;

                    case DialogInterface.BUTTON_NEGATIVE:
                        //No button clicked
                        break;
                }
                }
            };
            AlertDialog.Builder builder = new AlertDialog.Builder(getContext());
            builder.setMessage("Are you sure you want to delete this item?").setPositiveButton("Yes", dialogClickListener)
                    .setNegativeButton("No", dialogClickListener).show();
            return false;
            }
        });

        // Set visibility
        imageView_detailItem.setVisibility(View.VISIBLE);
        editText_detailItem_description.setVisibility(View.VISIBLE);
        editText_detailItem_user.setVisibility(View.VISIBLE);
        textView_detailItem_description.setVisibility(View.VISIBLE);
        textView_detailItem_user.setVisibility(View.VISIBLE);
        textView_detailItem_distance.setVisibility(View.VISIBLE);
        editText_detailItem_distance.setVisibility(View.VISIBLE);
        textView_detailItem_date.setVisibility(View.VISIBLE);
        editText_detailItem_date.setVisibility(View.VISIBLE);
        textView_detailItem_location.setVisibility(View.VISIBLE);
        editText_detailItem_location.setVisibility(View.VISIBLE);
        mapView_detailItem.setVisibility(View.VISIBLE);

        // Set info
        editText_detailItem_description.setText(Item.getDescription());
        UserContent.User tempUser = parentActivity.firebaseManager.userContent.getUserById(Item.getUserId());
        if(tempUser == null) { editText_detailItem_user.setText("Anonymous"); }
        else { editText_detailItem_user.setText(tempUser.getNickName()); }
        editText_detailItem_distance.setText(Double.toString(Item.getDistanceTo(parentActivity.currentLocationManager.mLastKnownLocation) / 1000.0) + " Km");
        editText_detailItem_date.setText(Item.getDateTime());

        // Set Item's Location
        editText_detailItem_location.setText(getDirection());

        if(googleMap != null) {
            googleMap.moveCamera(CameraUpdateFactory
                    .newLatLngZoom(new LatLng(Item.getLatitude(), Item.getLongitude()), DEFAULT_ZOOM));
        }

        // If image URL is present, try to show
        if(Item.getImageURL().toString().length() != 0) {
            FirebaseStorage storage = FirebaseStorage.getInstance();
            StorageReference storageRef = storage.getReferenceFromUrl(Item.getImageURL());
            try {
                final File localFile = File.createTempFile("images", "jpg");
                storageRef.getFile(localFile).addOnSuccessListener(new OnSuccessListener<FileDownloadTask.TaskSnapshot>() {
                    @Override
                    public void onSuccess(FileDownloadTask.TaskSnapshot taskSnapshot) {
                        Bitmap bitmap = BitmapFactory.decodeFile(localFile.getAbsolutePath());
                        imageView_detailItem.setImageBitmap(bitmap);
                        imageView_detailItem_fullscreen.setImageBitmap(bitmap);
                        progressBarAnimate(false, progressBar);

                    }
                }).addOnFailureListener(new OnFailureListener() {
                    @Override
                    public void onFailure(@NonNull Exception exception) {
                        progressBarAnimate(false, progressBar);
                    }
                });
            }
            catch (IOException e) {}
        }
        else {
            // STOP PROGRESS BAR ANIMATE
            progressBarAnimate(false, progressBar);
        }

    }

    public String getDirection() {
        Geocoder gcd = new Geocoder(getContext(), Locale.getDefault());
        List<Address> addresses = null;
        try {
            addresses = gcd.getFromLocation(Item.getLatitude(), Item.getLongitude(), 1);
        } catch (IOException e) {
            e.printStackTrace();
        }
        if(addresses != null) {
            if (addresses.size() > 0) { return addresses.get(0).getAddressLine(0); }
            else { return ""; }
        }
        else { return ""; }
    }

    public void progressBarAnimate (final boolean animateIn, final ProgressBar inProgressBar) {
        if(animateIn) {
            inProgressBar.setVisibility(View.VISIBLE);
            progressBarThread = new Thread() {
                @Override
                public void run() {
                    while (pStatus <= 100) {
                        handler.post(new Runnable() {
                            @Override
                            public void run() {
                                inProgressBar.setProgress(pStatus);
                                //txtProgress.setText(pStatus + " %");
                            }
                        });
                        try {
                            Thread.sleep(100);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                        pStatus++;
                    }
                }
            };
            progressBarThread.start();
        }
        else {
            inProgressBar.setVisibility(View.INVISIBLE);
            progressBarThread.interrupt();
        }
    }

}
