package mnk.replace.fragments;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.SeekBar.OnSeekBarChangeListener;

import mnk.replace.activities.NavigationDrawerActivity;
import mnk.replace.R;

/**
 * A simple {@link Fragment} subclass.
 */
public class FilterFragment extends Fragment implements OnSeekBarChangeListener {

    NavigationDrawerActivity parentActivity;

    TextView textView_distanceresult;
    Button button_filter_apply;
    TextView editText_tags;
    int filterDistance;
    String filterTags;

    public FilterFragment() {
        // Required empty public constructor
        filterDistance = -1;
        filterTags = "";
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.fragment_filter, container, false);
        parentActivity = ((NavigationDrawerActivity)getActivity());
        textView_distanceresult = (TextView) view.findViewById(R.id.textView_distanceresult);
        editText_tags = (TextView) view.findViewById(R.id.editText_tags);
        final SeekBar seekBar_distance = (SeekBar) view.findViewById(R.id.seekBar_distance);
        seekBar_distance.setOnSeekBarChangeListener(this);
        parentActivity.fab.setVisibility(View.INVISIBLE);
        filterDistance = -1;
        filterTags = "";

        button_filter_apply = (Button) view.findViewById(R.id.button_filter_apply);
        button_filter_apply.setOnClickListener( new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if(seekBar_distance.getProgress() == 10) { filterDistance = -1; }
                else { filterDistance = seekBar_distance.getProgress() + 1; }
                filterTags = editText_tags.getText().toString();
                parentActivity.fab.setVisibility(View.VISIBLE);
                // Hide keyboard
                final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
                getActivity().getSupportFragmentManager().popBackStack();
            }
        });

        // ACTION BAR BUTTONS
        if(parentActivity.filterItem != null) {
            parentActivity.actionBarShowFilterItem(false);
            parentActivity.actionBarShowViewItemsSelector(false, false);
        }

        return view;
    }

    @Override
    public void onStopTrackingTouch(SeekBar seekBar) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onStartTrackingTouch(SeekBar seekBar) {
        // TODO Auto-generated method stub
    }

    @Override
    public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
        // TODO Auto-generated method stub
        if(seekBar.getProgress() == 10) { textView_distanceresult.setText("No limit"); }
        else { textView_distanceresult.setText((seekBar.getProgress() + 1) + " Km"); }
    }

}
