package mnk.replace.fragments;

import android.content.Context;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.AuthResult;

import android.view.View.OnClickListener;

import mnk.replace.activities.NavigationDrawerActivity;
import mnk.replace.R;

/**
 * A simple {@link Fragment} subclass.
 */
public class LoginFragment extends Fragment {

    private int RC_SIGN_IN = 0;
    private GoogleApiClient mGoogleApiClient;
    public Button button_signwithGmail;
    NavigationDrawerActivity parentActivity;

    public LoginFragment() {
        // Required empty public constructor
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_login, container, false);
        parentActivity = ((NavigationDrawerActivity)getActivity());
        final EditText editText_user = (EditText) view.findViewById(R.id.editText_email);
        final EditText editText_password = (EditText) view.findViewById(R.id.editText_password);
        Button button_signwithEmail = (Button) view.findViewById(R.id.button_signwithEmail);
        Button button_createnewwithEmail = (Button) view.findViewById(R.id.button_createnewwithEmail);
        button_signwithGmail = (Button) view.findViewById(R.id.button_signwithGmail);
        parentActivity.fab.setVisibility(View.INVISIBLE);

        button_signwithEmail.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
            OnCompleteListener<AuthResult> completeListener = new OnCompleteListener<AuthResult>() {
                @Override
                public void onComplete(@NonNull Task<AuthResult> task) {
                    if (task.isSuccessful()) {
                        parentActivity.firebaseManager.updateCurrentUser();
                        parentActivity.updateUIUser();
                        Toast.makeText(getContext(), "Hello " + parentActivity.firebaseManager.getCurrentUserDisplayName(), Toast.LENGTH_LONG).show();
                        // Button visibility
                        parentActivity.fab.setVisibility(View.VISIBLE);
                        getFragmentManager().popBackStack();
                    } else {
                        Toast.makeText(getActivity(), "Authentication failed",
                                Toast.LENGTH_SHORT).show();
                    }
                }
            };
            if(protectEmailAndPassword(editText_user.getText().toString(), editText_password.getText().toString())) {
                parentActivity.firebaseManager.firebaseAuth.signInWithEmailAndPassword(editText_user.getText().toString(), editText_password.getText().toString()).addOnCompleteListener(getActivity(), completeListener);
                // Hide keyboard
                final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
            }
            }
        });
        button_createnewwithEmail.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                OnCompleteListener<AuthResult> completeListener = new OnCompleteListener<AuthResult>() {
                    @Override
                    public void onComplete(@NonNull Task<AuthResult> task) {
                        if (task.isSuccessful()) {
                            // Sign in success, update UI with the signed-in user's information
                            parentActivity.firebaseManager.updateCurrentUser();
                            parentActivity.firebaseManager.addCurrentUserToDatabase();
                            parentActivity.updateUIUser();
                            Toast.makeText(getContext(), "Hello " + parentActivity.firebaseManager.getFirebaseUser().getEmail(), Toast.LENGTH_LONG).show();
                            // Button visibility
                            parentActivity.fab.setVisibility(View.VISIBLE);
                            getFragmentManager().popBackStack();
                        } else {
                            // If sign in fails, display a message to the user.
                            Toast.makeText(getActivity(), "User creation failed",
                                    Toast.LENGTH_SHORT).show();
                        }
                    }
                };
                if(protectEmailAndPassword(editText_user.getText().toString(), editText_password.getText().toString())) {
                    parentActivity.firebaseManager.getFirebaseAuth().createUserWithEmailAndPassword(editText_user.getText().toString(), editText_password.getText().toString()).addOnCompleteListener(getActivity(), completeListener);
                    // Hide keyboard
                    final InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
                    imm.hideSoftInputFromWindow(getView().getWindowToken(), 0);
                }
            }
        });
        button_signwithGmail.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                parentActivity.firebaseManager.loginGoogle();
                // Button visibility
                parentActivity.fab.setVisibility(View.VISIBLE);
                getFragmentManager().popBackStack();
            }
        });

        // ACTION BAR BUTTONS
        if(parentActivity.filterItem != null) {
            parentActivity.actionBarShowFilterItem(false);
            parentActivity.actionBarShowViewItemsSelector(false, false);
        }

        return view;
    }

    public boolean protectEmailAndPassword(String Email, String Password) {

        if(Email.length() == 0) {

            Toast.makeText(getContext(), "Introduzca email por favor", Toast.LENGTH_SHORT).show();
            return false;

        }
        else if(Password.length() == 0) {

            Toast.makeText(getContext(), "Introduzca password por favor", Toast.LENGTH_SHORT).show();
            return false;

        }

        return true;

    }

    @Override
    public void onStart() {
        super.onStart();
    }

}