package mnk.replace.model;

import android.location.Location;

import java.util.ArrayList;
import java.util.List;

public class ItemContent {

    public List<Item> ITEMS = new ArrayList<>();

    public ItemContent() {

        ITEMS = new ArrayList<>();

    }

    public void addItem(Item item) {

        ITEMS.add(item);

    }

    public Item getItem(int x) {

        return ITEMS.get(x);
    }

    public Item getItemById(String id) {

        for(int x = 0; x < ITEMS.size(); x++) {

            if(ITEMS.get(x).getId().compareTo(id) == 0) {

                return ITEMS.get(x);

            }

        }

        return null;
    }

    public void removeItems() {

        ITEMS = new ArrayList<>();

    }

    public List<Item> getItems() {

        return ITEMS;

    }

    public boolean checkUsedId(String id) {

        if(id == "") { return true; }

        for(int x = 0; x < ITEMS.size(); x++) {

            if(ITEMS.get(x).getId().equals(id)) {

                return true;

            }

        }

        return false;

    }

    public void sortByDistance(Location inLocation) {

        Location loc1 = new Location("");
        Location loc2 = new Location("");

        for(int x = 0; x < ITEMS.size(); x++) {

            for(int y = x + 1; y < ITEMS.size(); y++) {

                loc1.setLongitude(ITEMS.get(x).getLongitude());
                loc1.setLatitude(ITEMS.get(x).getLatitude());

                loc2.setLongitude(ITEMS.get(y).getLongitude());
                loc2.setLatitude(ITEMS.get(y).getLatitude());

                if (loc1.distanceTo(inLocation) > loc2.distanceTo(inLocation)) {

                    ItemContent.Item tempItem = new ItemContent.Item(ITEMS.get(y));
                    ITEMS.set(y, ITEMS.get(x));
                    ITEMS.set(x, tempItem);
                    y = ITEMS.size();
                    x = -1;

                }

            }

        }

    }

    public List<Item> getFilteredItems(Location inCurrentLocation, int inDistance, String inTags) {

        boolean keyFilter;
        List<Item> filteredItems = new ArrayList<>();

        for(int x = 0; x < ITEMS.size(); x++) {

            keyFilter = false;

            // APPLY THE TAGS FILTER
            if((inTags != "") && (ITEMS.get(x).description.toLowerCase().indexOf(inTags.toLowerCase()) == -1)){ }
            else {
                if(inDistance == -1) {
                    filteredItems.add(ITEMS.get(x));
                }
                else {
                    // APPLY THE DISTANCE FILTER
                    Location loc1 = new Location("");
                    loc1.setLatitude(ITEMS.get(x).getLatitude());
                    loc1.setLongitude(ITEMS.get(x).getLongitude());

                    if (loc1 == null || inCurrentLocation == null) {
                        filteredItems.add(ITEMS.get(x));
                    } else if (loc1.distanceTo(inCurrentLocation) < (inDistance * 1000)) {
                        filteredItems.add(ITEMS.get(x));
                    }
                }

            }

        }

        return filteredItems;

    }

    public static class Item {

        public String description;
        public Double latitude;
        public Double longitude;
        public String userId;
        public String imageURL;
        public String id;
        public String dateTime;

        public Item() {

            this.description = "";
            this.latitude = 0.0;
            this.longitude = 0.0;
            this.userId = "";
            this.imageURL = "";
            this.id = "";
            this.dateTime = "";

        }

        public Item(Item item) {

            this.description = item.description;
            this.latitude = item.latitude;
            this.longitude = item.longitude;
            this.userId = item.userId;
            this.imageURL = item.imageURL;
            this.id = item.id;
            this.dateTime = item.dateTime;

        }

        public Item(String Description, Double Latitude, Double Longitude, String UserId, String ImageURL, String Id, String DateTime) {

            this.description = Description;
            this.latitude = Latitude;
            this.longitude = Longitude;
            this.userId = UserId;
            this.imageURL = ImageURL;
            this.id = Id;
            this.dateTime = DateTime;

        }

        public String getDescription() {
            return description;
        }

        public void setDescription(String Description) {
            description = Description;
        }

        public Double getLatitude() {
            return latitude;
        }

        public void setLatitude(Double Latitude) {
            latitude = Latitude;
        }

        public Double getLongitude() {
            return longitude;
        }

        public void setLongitude(Double Longitude) {
            longitude = Longitude;
        }

        public String getUserId() {
            return userId;
        }

        public void setUserId(String UserId) {
            userId = UserId;
        }

        public String getImageURL() {
            return imageURL;
        }

        public void setImageURL(String ImageURL) {
            imageURL = ImageURL;
        }

        public String getId() {
            return id;
        }

        public void setId(String Id) {
            id = Id;
        }

        public String getDateTime() {
            return dateTime;
        }

        public void setDateTime(String DateTime) {
            dateTime = DateTime;
        }

        public int getDistanceTo(Location inCurrentLocation) {

            // APPLY THE DISTANCE FILTER
            Location loc1 = new Location("");
            loc1.setLatitude(latitude);
            loc1.setLongitude(longitude);

            if(inCurrentLocation == null) { return 0; }
            else { return Math.round(loc1.distanceTo(inCurrentLocation)); }

        }

    }

}
